package com.eactive.eai.batch.job.jobItem.insure;

import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

/**
 * 퇴직연금용 0800 전문 수신용 텔레그램 클래스
 */
public class RECV_INSBT_0800 extends DefaultTelegram implements TelegramService
{
    //>> 거래구분코드 정의
    // 업무개시
    private final String TrClass_start      = "061000";
    private final String TrClass_end        = "063000";

    /**
     * 생성자
     */
    public RECV_INSBT_0800() {
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        
        //거래구분코드 체크
        String bizCode = this.getTrClass();
        if (bizCode.equalsIgnoreCase(this.TrClass_start)) {
            logger.info("{} BATCH JOB : start request received", logHeader);
            
        } else if(bizCode.equalsIgnoreCase(this.TrClass_end)) {
            logger.info("{} BATCH JOB : end request received", logHeader);
            
        } else {
            logger.info("{} 0800 telegram : unknown trasaction classification code received >> "+this.getTrClass(), logHeader);
        }

        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        
        return true;
    }

    /**
     * doPostExecute
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 비정형 필드에 대한 수신길이 계산
     */
    public int getCalculatedLength(int idx) {
        logger.info("{} getCalculatedLength unexpectedly called : idx = " + idx, logHeader);
        return 0;
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(7);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(8);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(11);
    }

}
